using fichier1.Data;
using fichier1.Views;
using Microsoft.EntityFrameworkCore;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using System;
using System.Collections.Generic;
using System.Configuration;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using System.Windows.Forms;
using fichier1.Controllers;
using fichier1.Model;

namespace fichier1
{
    static class Program
    {
        /// <summary>
        ///  The main entry point for the application.
        /// </summary>
        public static ServiceProvider ServiceProvider { get; private set; }

        [STAThread]
        static void Main()
        {
            var path = Path.GetDirectoryName(AppDomain.CurrentDomain.BaseDirectory);
            var path1 = Path.Combine(path, "..", "..", "..");
            // setup l'injection de dpendance
            var serviceCollection = new ServiceCollection();
            serviceCollection.AddDbContext<BddContext>(options =>
                options.UseSqlite($"Data Source={path1}\\Bdd.db"));

            Application.SetHighDpiMode(HighDpiMode.SystemAware);
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            serviceCollection.AddScoped<MainForm>();
            serviceCollection.AddScoped<Partie>();
            serviceCollection.AddScoped<CorrectionMot>();
            serviceCollection.AddScoped<ViewDecoupage>();
            serviceCollection.AddScoped<ViewResultats>();
            serviceCollection.AddScoped<IGameController, GameController>();

            ServiceProvider = serviceCollection.BuildServiceProvider();
            ServiceProvider.GetRequiredService<BddContext>().Database.EnsureCreated();

            var form1 = ServiceProvider.GetRequiredService<MainForm>();
            Application.Run(form1);
        }
    }
}
